Loading...
Searching...
No Matches
juce::JSObject Class Reference

## Detailed Description

A JSObject represents an owning reference to the underlying JS object, meaning it will remain valid even if a subsequent script execution deletes other handles to it.

Objects of this class can be used to traverse the current object graph inside the specified Javascript engine.

This is a low-level providing only operations that map directly to the underlying Javascript Object implementation. The JSCursor class generally provides a more convenient interface with functions that may fail based on the Javascript engine's current state.

See also
  JSCursor

The documentation for this class was generated from the following file:

- juce_javascript/javascript/juce_JSObject.h

## Public Member Functions

| JSObject (detail::QuickJSWrapper *engine)
| Constructor, used internally by the JavascriptEngine implementation.
| ~JSObject ()
| Destructor.
| JSObject (const JSObject &)
| Copy constructor.
| JSObject (JSObject &&) noexcept
| Move constructor.
JSObject & | operator= (const JSObject &)
| Copy assignment operator.
JSObject & | operator= (JSObject &&) noexcept
| Move assignment operator.
JSObject | getChild (const Identifier &name) const
| Returns a new cursor pointing to a JS object that is a property of the parent cursor's underlying object and has the provided name.
JSObject | operator[] (const Identifier &name) const
| Returns a cursor object pointing to the property with the given name.
JSObject | getChild (int64 index) const
| Returns a new cursor object pointing to the specified element in an Array.
JSObject | operator[] (int64 index) const
| Returns a new cursor object pointing to the specified element in an Array.
bool | isArray () const
| Returns true if the JS Object under the cursor is an Array.
int64 | getSize () const
| Returns the size of the underlying JS Array.
bool | hasProperty (const Identifier &name) const
| Returns true if the object under the cursor has a property with the given name.
var | get () const
| Returns a variant with a value of the property under the given name.
void | setProperty (const Identifier &name, const var &value) const
| Adds a named property to the underlying Object with the provided value, or assigns this value to an existing property with this name.
void | setProperty (int64 index, const var &value) const
| Adds a property with an integral identifier and the provided value to the underlying Object, or assigns the value to an existing property.
var | invokeMethod (const Identifier &methodName, Span< const var > args, Result *result=nullptr) const
| Invokes this node as though it were a method.
NamedValueSet | getProperties () const
| Returns all properties of the current object that are own properties, i.e.

## Constructors and Destructors

## JSObject() [1/3]

juce::JSObject::JSObject | ( | detail::QuickJSWrapper * | engine | ) |

explicit

Constructor, used internally by the JavascriptEngine implementation.

To create a new JSObject pointing at the root object of the engine's context use JavascriptEngine::getRootObject().

Referenced by getChild(), getChild(), getProperties(), JSObject(), JSObject(), operator=(), operator=(), operator[](), and operator[]().

## ~JSObject()

juce::JSObject::~JSObject | ( |  | ) |

Destructor.

## JSObject() [2/3]

juce::JSObject::JSObject | ( | const JSObject & |  | ) |

Copy constructor.

References JSObject().

## JSObject() [3/3]

juce::JSObject::JSObject | ( | JSObject && |  | ) |

noexcept

Move constructor.

References JSObject().

## Member Functions

## operator=() [1/2]

JSObject & juce::JSObject::operator= | ( | const JSObject & |  | ) |

Copy assignment operator.

References JSObject().

## operator=() [2/2]

JSObject & juce::JSObject::operator= | ( | JSObject && |  | ) |

noexcept

Move assignment operator.

References JSObject().

## getChild() [1/2]

JSObject juce::JSObject::getChild | ( | const Identifier & | name | ) | const

Returns a new cursor pointing to a JS object that is a property of the parent cursor's underlying object and has the provided name.

You can use hasProperty() to check if such a property exists prior to the creation of this cursor. If no such property exists, this constructor will create a new JS Object and attach it to the parent under the specified name. This can be used to manipulate the object graph.

References getChild(), JSObject(), and name.

Referenced by getChild(), and getChild().

## operator[]() [1/2]

JSObject juce::JSObject::operator[] | ( | const Identifier & | name | ) | const

Returns a cursor object pointing to the property with the given name.

If such property doesn't exist it will be created as an empty JS Object. Shorthand for getChild.

References JSObject(), and name.

## getChild() [2/2]

JSObject juce::JSObject::getChild | ( | int64 | index | ) | const

Returns a new cursor object pointing to the specified element in an Array.

You must ensure that the cursor points to an Array before calling this function.

See also
  isArray

References getChild(), and JSObject().

## operator[]() [2/2]

JSObject juce::JSObject::operator[] | ( | int64 | index | ) | const

Returns a new cursor object pointing to the specified element in an Array.

This function is a shorthand for getChild (int64).

You must ensure that the cursor points to an Array before calling this function.

See also
  isArray

References JSObject().

## isArray()

bool juce::JSObject::isArray | ( |  | ) | const

Returns true if the JS Object under the cursor is an Array.

You can use getChild() or operator[]() to get a cursor to individual elements in the array or get() to obtain a JUCE variant wrapping all array elements.

References isArray().

Referenced by isArray().

## getSize()

int64 juce::JSObject::getSize | ( |  | ) | const

Returns the size of the underlying JS Array.

You must ensure that the cursor points to an Array before calling this function.

See also
  isArray

References getSize().

Referenced by getSize().

## hasProperty()

bool juce::JSObject::hasProperty | ( | const Identifier & | name | ) | const

Returns true if the object under the cursor has a property with the given name.

References hasProperty(), and name.

Referenced by hasProperty().

## get()

var juce::JSObject::get | ( |  | ) | const

Returns a variant with a value of the property under the given name.

If no such property exists an undefined variant is returned.

If this property points to an object created by JavascriptEngine::registerNativeObject(), then the returned variant will contain a pointer to the original object and can be acquired by variant::getDynamicObject().

References get().

Referenced by get().

## setProperty() [1/2]

void juce::JSObject::setProperty | ( | const Identifier & | name,
|  | const var & | value ) const

Adds a named property to the underlying Object with the provided value, or assigns this value to an existing property with this name.

References name, and setProperty().

Referenced by setProperty(), and setProperty().

## setProperty() [2/2]

void juce::JSObject::setProperty | ( | int64 | index,
|  | const var & | value ) const

Adds a property with an integral identifier and the provided value to the underlying Object, or assigns the value to an existing property.

If the underlying Object is also an Array, then the provided value will be assigned to the specified element of this Array, and ensure that it will have a size of at least index - 1.

References setProperty().

## invokeMethod()

var juce::JSObject::invokeMethod | ( | const Identifier & | methodName,
|  | Span< const var > | args,
|  | Result * | result = nullptr ) const

Invokes this node as though it were a method.

If the optional Result pointer is provided it will contain Result::ok() in case of success, or an error message in case an exception was thrown during evaluation.

References invokeMethod().

Referenced by invokeMethod().

## getProperties()

NamedValueSet juce::JSObject::getProperties | ( |  | ) | const

Returns all properties of the current object that are own properties, i.e.

not inherited.

References getProperties(), and JSObject().

Referenced by getProperties().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited